//
// $Id: Factory.cpp 76591 2007-01-25 18:17:52Z elliott_c $
//
#include "Factory.h"
#include "Simple.h"

ACE_RCSID(Activation, Factory, "$Id: Factory.cpp 76591 2007-01-25 18:17:52Z elliott_c $")

Factory::Factory (CORBA::ORB_ptr orb)
  : orb_ (CORBA::ORB::_duplicate (orb))
{
}

Test::Simple_ptr
Factory::create_simple_object (void)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  Simple *simple_impl;
  ACE_NEW_THROW_EX (simple_impl,
                    Simple,
                    CORBA::NO_MEMORY ());

  PortableServer::ServantBase_var owner_transfer(simple_impl);

  return simple_impl->_this ();
}

void
Factory::shutdown (void)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  this->orb_->shutdown (0);
}
